<?php
/**
 * sidebar template
 *
 * @author LeapIn Corp.
 * @since 1.0.0
 */
?>
<?php
$sidebar_front = '';
if(is_front_page()){
    $sidebar_front = ' front';
}else if(is_home()){
    $sidebar_front = ' home';
}
?>
<aside id="sidebar1" class="sidebar cf<?php echo $sidebar_front; ?>" role="complementary"
       itemtype="http://schema.org/WPSideBar">

    <?php if (is_singular() && !(is_home() || is_front_page())): ?>

        <?php if (is_active_sidebar('sidebar_single')) : ?>

            <?php dynamic_sidebar('sidebar_single'); ?>

        <?php elseif (is_active_sidebar('sidebar1')) : ?>
            <?php dynamic_sidebar('sidebar1'); ?>

        <?php else: ?>

            <div class="no-widgets">
                <p><?php _e('This is a widget ready area. Add some and they will appear here.', 'pjax-blog'); ?></p>
            </div>

        <?php endif; ?>

    <?php else: ?>
        <?php if (is_active_sidebar('sidebar1')) : ?>

            <?php dynamic_sidebar('sidebar1'); ?>

        <?php else: ?>

            <div class="no-widgets">
                <p><?php _e('This is a widget ready area. Add some and they will appear here.', 'pjax-blog'); ?></p>
            </div>

        <?php endif; ?>
    <?php endif; ?>

</aside>


